//
//  ViewController.swift
//  Dropsy
//
//  Created by Howard Oakley on 11/04/2018.
//  Copyright © 2018 EHN & DIJ Oakley. All rights reserved.
//

import Cocoa

class ViewController: NSViewController, NSWindowDelegate {
    @IBOutlet var outputScroller: NSScrollView!
    @IBOutlet var outputTextcontent: NSTextView!
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }
    
    func replaceOutputText(string: String) {
        let myString = NSAttributedString(string: string)
        outputTextcontent.textStorage?.setAttributedString(myString)
    }
    
    func appendOutputText(string: String) {
        let myString = NSAttributedString(string: string)
        outputTextcontent.textStorage?.append(myString)
    }

    override func viewDidAppear() {
        self.view.window?.delegate = self
        if let theDoc = self.view.window?.windowController?.document as! Document? {
            if let sourceUrl = theDoc.fileURL {
                let theFName1 = sourceUrl.deletingPathExtension().lastPathComponent
                var theFExt1 = sourceUrl.pathExtension
                if theFExt1 != "" {
                    theFExt1 = "." + theFExt1
                }
                let FS = NSSavePanel()
                FS.showsHiddenFiles = true
                FS.treatsFilePackagesAsDirectories = true
                FS.canCreateDirectories = true
                FS.prompt = "Duplicate to file"
                FS.message = "Enter the name of a new file"
                FS.nameFieldStringValue = theFName1 + "-Copy" + theFExt1
                FS.beginSheetModal(for: self.view.window!) { result in
                    if result.rawValue == NSFileHandlingPanelOKButton {
                        guard let destUrl = FS.url else { return }
                        let FM = FileManager.default
                        do {
                            try FM.copyItem(at: sourceUrl, to: destUrl)
                            let theAttrs = try FM.attributesOfItem(atPath: sourceUrl.path)
                            try FM.setAttributes(theAttrs, ofItemAtPath: destUrl.path)
                            let theStr = "Saved copy of " + sourceUrl.lastPathComponent + " to " + destUrl.lastPathComponent + "\n"
                            self.appendOutputText(string: theStr)
                        } catch {
                            self.appendOutputText(string: error.localizedDescription)
                        }
                    }
                }
            }
        }
    }

    override var representedObject: Any? {
        didSet {
        // Update the view, if already loaded.
        }
    }


}

